program CxTrDemo;
{$APPTYPE CONSOLE}

uses
  SysUtils,  windows,
  CxTranslator in 'CxTranslator.pas';

function toRad(var x: TComplex):TComplex; stdcall;
var res:TComplex;
begin
        res.Im:=0;
        res.re:=x.re*3.14/180;
        toRad:=res;
end;

var
  args:array[0..2] of TComplex;
  res:TComplex;
  twoPi:TComplex;
  mathFunc:PChar;
  mathExp:PChar;
  varList:PChar;

 begin

 args[0].Re:=3.6;args[0].Im:=6;
 args[1].Re:=5.6;args[1].Im:=-4;
 args[2].Re:=-1.5;args[2].Im:=0.33;
 twoPi.Re:=6.28;      twoPi.Im:=0;

  mathFunc := 'f(x,y,z)=3*x^2-y^2i+sqrt(toRad(45))/twoPi';
  mathExp := '3*x^2-y^2+exp(85)/4i+twoPi';
  varList := 'x y z';

    try
      AddFunction('toRad', @toRad);
       AddConst('twoPi', twoPi);

        BuildEqu(mathFunc);
	res := CalcFor(@args);
	writeln('Re=',res.Re,'    Im=',res.Im);

 	RemoveFunction('toRad');
    	Build('', 'twoPi/2');
	res := CalcFor(@args);
	writeln('Re=',res.Re,'    Im=',res.Im);

   	AddFunction('toRad', @toRad);
	res := EvaluateEqu(mathFunc, @args);
	writeln('Re=',res.Re,'    Im=',res.Im);

     	RemoveConst('twoPi');
	res :=Evaluate(varList, mathExp, @args);  //Error
	writeln('Re=',res.Re,'    Im=',res.Im);


    except
          on E:Exception do writeln('Exception: '+e.Message);

        end;

   readln;
 end.

